//*************************************
//          Reichel Bartosz
//          reichel@mif.pg.gda.pl
//          http://reichel.pl
//          2006.08.19
//*************************************
unit MyInterface;

interface
uses Windows, ActiveX, COmObj;

//Scieka w rejestrze, pod ktr naley rejestrowa
//nowe rozszerzenia. Naley utworzy klucz z numerem
//GUID np:
//SOFTWARE\PFS\Examples\Wtyczki\{000C0AF6-5B6E-47BF-90F2-82E15480AB96}
//
const
 //HKEY_CURRENT_USER
 szWtyczki  = 'SOFTWARE\PFS\Examples\Wtyczki';


const
 SID_IPlugsApplication = '{822C0AF6-5B6E-47BF-90F2-82E15480AB96}';
 IID_IPlugsApplication: TGUID = '{822C0AF6-5B6E-47BF-90F2-82E15480AB96}';
 
//******************  IPlugsApplication ******************
//-----------
//function ChangeColor(NewColor:TColorRef):HResult;stdcall;
//
//funkca ChangeColor pozwala zmieni,
//kolor ta aplikacji rodzica. Jako parametr kolor w postaci RGB.
//-----------
//function GetHandle(out hwnd:HWND):HResult;stdcall;
//
//funkcja GetHandle zwraca uchwyt okna rodzica w parametrze hwnd
//*******************************************************
type
  IPlugsApplication = interface(IInterface)
  [SID_IPlugsApplication]
  function ChangeColor(NewColor:TColorRef):HResult;stdcall;
  function GetHandle(out hwnd:HWND):HResult;stdcall;
end;

const
 SID_IPlug = '{E2F26AD7-4A48-4CE4-8CC8-76192E0E9640}';
 IID_IPlug: TGUID = '{E2F26AD7-4A48-4CE4-8CC8-76192E0E9640}';

 SID_IPlugSuper = '{E9F1E678-C99B-46C2-A51F-AA4197182C73}';
 IID_IPlugSuper: TGUID = '{E9F1E678-C99B-46C2-A51F-AA4197182C73}';

//************************ IPlug ************************
//*******************************************************
//function Init(ap:IPlugsApplication;TabH:HWND): HResult; stdcall;
//
//W przypadku gdy implementujemy interfejs IPlugsApplication
//
//Funkcja Init jest najwaniejsz czci skadow
//wtyczki opartej o IPlug i musi by zaimplementowana.
//Jako parametr naley poda istniejcy wskanik do
//interfejsu aplikacji rodzica IPlugsApplication. W przeciwny
//wypadku funkcja zwrci warto E_FAIL.
//
//Dla osb implementujcych interfejs IPlug.
//
//Funkcja Init musi by zaimplementowana.
//W parametrze ap powinien znajdowa si wskanik do
//interfejsu IPlugsApplication. Jeli przyjmuje on
//warto pust funkcja Init powinna zwrci kod
//E_FAIL i zakoczy inicjacje. W przypadku gdy wskanik
//jest poprawny, to naley w tej funkcji utworzy okno
//wtyczki. W przypadku gdy parametr TabH jest rny od
//zera, okno moe by utworzone z parametrem WS_CHILD.
//Jako warto okrelajc powodzenie naley zwrci S_OK
//---------------
//
// function Mouse(Name:PChar;X,Y:Integer): HResult; stdcall;
//
//Dla implementujcych IPlugsApplication
//
//Do funkcji mona przekaza parametry:
//      Name - opisujcy nad czym znajduje si kursor
//      X,Y  - pozycje kursora myszy
//
//Dla implementujcych interfejs IPlug
//
//Funkcja moe by nie zaimplementowana i zwrci E_NOIMPL.
//W przypadku gdy funkcja jest zaimplementowana
//mona reagowa na parametry Name, X,Y w zalenoci
//od zastosowania wtyczki.
//
//
//function GetName(var Desc:PChar):HResult; stdcall;
//
//Funkcja przekazuje dodatkowe informacje o wtyczcce.
//
//Funkcja GetName moe by nie zaimplementowana i zwrci
//warto E_NOIMPL. W przypadku gdy jest zaimplementowana
//Powinna zarezerwowa odpowiedni ilo pamici dla zmiennej
//Name. Za zwolnienie pamici odpowiedzialny jest wywoujcy
//funkcje.
//
//
//function FreePlug(): HResult; stdcall;
//
//Funkcja FreePlug zwalnia zasoby pamici zarezerwowane
//podczas dziaania wtyczki.
//
//Powinna zwrci warto S_OK.
//
//*******************************************************
//*******************************************************
type
  IPlug = interface(IInterface)
    [SID_IPlug]
    function Init(ap:IPlugsApplication;TabH:HWND): HResult; stdcall;
    function Mouse(Name:PChar;X,Y:Integer): HResult; stdcall;
    function GetName(var Desc:PChar):HResult; stdcall;
    function FreePlug(): HResult; stdcall;
  end;

//*********************** IPlugSuper ********************
//*******************************************************
//Interfejs IPlugSuper jest rozszerzeniem interfejsu
//IPlug. Implementujcy ten interfejs powinien
//te zaimplementowa funkcje interfejsu IPlug.
//
//
//function Super(): HResult; stdcall;
//
//Funkcja Super powinna zwrci S_OK i zrobi co Super!
//
//*******************************************************
//*******************************************************

type
  IPlugSuper = interface(IPlug)
    [SID_IPlugSuper]
    function Super(): HResult; stdcall;
  end;
implementation


end.
