unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MyInterface, ComCtrls, Menus, ToolWin, ActiveX;

type
  PPlugs = ^TPlugs;
  TPlugs = packed record
     Loaded:Boolean;
     Int:IPlug;
     IsSuper:Boolean;
     CLSID:String;
     Path:String;
     Name:String;
     Tab:TTabSheet;
end;     
const
 cStatus:array[Boolean] of String = ('Zatrzymana', 'Uruchomiona');
type
  TForm1 = class(TForm, IPlugsApplication)
    ListView1: TListView;
    OpenDialog1: TOpenDialog;
    ToolBar1: TToolBar;
    LoadPlug: TButton;
    RegisterPlug: TButton;
    UnloadPlug: TButton;
    UnregisterPlug: TButton;
    Button2: TButton;
    Super: TButton;
    Button1: TButton;
    PageControl1: TPageControl;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure LoadPlugClick(Sender: TObject);
    procedure UnloadPlugClick(Sender: TObject);
    procedure Button1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UnregisterPlugClick(Sender: TObject);
    procedure RegisterPlugClick(Sender: TObject);
    procedure SuperClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    pMalloc:IMalloc;
    procedure ListPlugs;
    function CheckForPlug(CLSID:String):boolean;
//IPlugsApplication
    function ChangeColor(NewColor:TColorRef):HResult;stdcall;
    function GetHandle(out hwnd:HWND):HResult;stdcall;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Registry,  OCXUnit, CommCtrl, ShlObj, ComObj;
{$R *.dfm}

//Funkcja rejestruje nazwy interfejsow w kluczu
//HHKEY_CLASSES_ROOT\Interface\{Numer CLSID}    
procedure RegisterInterfaces;
var
 Reg:TRegistry;
begin
  Reg := TRegistry.Create;
  try
   Reg.RootKey := HKEY_CLASSES_ROOT;
   Reg.OpenKey('Interface\'+SID_IPlugsApplication,True);
   Reg.WriteString('','IPlugsApplication');
   Reg.CloseKey;

   Reg.OpenKey('Interface\'+SID_IPlug,True);
   Reg.WriteString('','IPlug');
   Reg.CloseKey;

   Reg.OpenKey('Interface\'+SID_IPlugSuper,True);
   Reg.WriteString('','IPlugSuper');
   Reg.CloseKey;
  finally
   Reg.free;
  end;
end;

procedure GetInfoFromCLSID(C:TGUID; var name, path:String);
var
 Reg:TRegistry;
begin
   name := '';
   path := '';
   Reg := TRegistry.Create;
   try
    Reg.RootKey := HKEY_CLASSES_ROOT;
    if Reg.OpenKey('CLSID\'+GuidToString(C),false) then
    begin
      name := Reg.ReadString('');
      Reg.CloseKey;
      if Reg.OpenKey('CLSID\'+GuidToString(C)+'\InprocServer32',false) then
      begin
       path := Reg.ReadString('');
       Reg.CloseKey;
      end;
    end;
   finally
     Reg.Free;
   end;   

end;

//TO rozwiazanie jest dalekie (bardzo dalekie od ideau)
//jednak pomysl aby sprawdzac czy wtyczka jest juz w liscie przyszedl
//mi na koncu i w zwiazku z tym, nie mam sil przebudowoywac calej ideii programu.
function TForm1.CheckForPlug(CLSID:String):boolean;
var
 I:Integer;
 PR:PPlugs;
begin
Result := False;
if ListView1.Items.Count > 0 then
 for i:= 0 to ListView1.Items.Count -1 do
 begin
  PR := ListView1.Items[i].Data;
  if Assigned(PR) then
    if CompareText(PR.CLSID, CLSID) = 0 then
    begin
      Result := True;
      Break;
    end;
 end;

end;


procedure TForm1.ListPlugs;
var
 Reg:TRegistry;
 SL:TStringList;
 i:integer;
 WtykaGUID:TGUID;
 HR:HResult;
 PR:PPlugs;
 W:IPlug;
 Wname,Wpath:String;
 LI:TListItem;
 SW:IPlugSuper;
begin
   Screen.Cursor := crHourGlass;
   Button2.Enabled := False;
   ListView1.Items.BeginUpdate;
   try
    Reg := TRegistry.Create;
    try
     Reg.RootKey := HKEY_CURRENT_USER;
     Reg.OpenKey(szWtyczki,True);
     SL := TStringList.Create;
     try
      Reg.GetKeyNames(SL);
      if SL.Count > 0 then
       for i := 0 to SL.Count - 1 do
       begin
        
        if not CheckForPlug(SL[i]) then
        begin
        WtykaGUID := StringToGuid(SL[i]);
        HR := CoCreateInstance(WtykaGUID,nil,CLSCTX_INPROC_SERVER,IID_IPlug,W);
        if SUCCEEDED(HR) then
        begin
         GetInfoFromCLSID(WtykaGUID,Wname, Wpath);
         LI := ListView1.Items.Add;
         New(PR);
         PR^.Int := nil;//na razie interfejsu nie ma - jest niezaladowana
         PR^.Loaded := False;
         PR^.IsSuper := False;
         PR^.Path := WPath;
         PR^.Name := WName;
         PR^.CLSID := SL[i];
         LI.Data := PR;
         LI.Caption := IntToStr(i);
         LI.SubItems.Add(Wname);//nazwa
         LI.SubItems.Add(cStatus[False]);
         if SUCCEEDED(W.QueryInterface(IID_IPlugSuper,SW)) then
         begin
          LI.SubItems.Add('TAK');//Czy super wtyczka
          PR^.IsSuper := True;
         end
         else
          LI.SubItems.Add('NIE');

         LI.SubItems.Add(Wpath);//scieka
         LI.SubItems.Add(SL[i]);   //CLSID
         W := nil;
        end; 
        end;
      end;
     finally
      SL.Free;
     end;
    finally
     Reg.Free;
    end;
   finally
    ListView1.Items.EndUpdate;
    Button2.Enabled := True;
    Screen.Cursor := crDefault;
   end;  
end;

function TForm1.ChangeColor(NewColor:TColorRef):HResult;
begin
  Color := NewColor;
  result := S_OK;
end;

function TForm1.GetHandle(out hwnd:HWND):HResult;
begin
 // hwnd := panel1.Handle;
  result := S_OK;  
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   RegisterInterfaces;
   CoInitialize(nil);
   SHGetMalloc(pMalloc);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
 I:Integer;
 PR:PPlugs;
begin
//W przypadku gdy interfejsy sa gdzies 'zamotane' w pamieci
//nalezy je zwolnic samemu !!

if ListView1.Items.Count > 0 then
 for i:= 0 to ListView1.Items.Count -1 do
 begin
  PR := ListView1.Items[i].Data;
  if Assigned(PR) and PR^.Loaded then //uwaga gdy wlaczne sprawdzanie wszystkich warunkow to sie posypie
  begin
    PR^.Int := nil; //zwalniamy wtyczke (to samo co _Release - nie pamietam od ktorej wersji delphi tak mozna)
    PR^.Tab.Free;
  end;
  if Assigned(PR) then Dispose(PR);//no i zwalniamy pamieci przydzielona do rekordow
 end;

   pMalloc := nil;
   CoUnInitialize;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ListPlugs;
end;

procedure TForm1.ListView1Click(Sender: TObject);
var
 PR:PPlugs;
 LI:TListItem;
begin
UnregisterPlug.Enabled := False;
UnloadPlug.Enabled := False;
LoadPlug.Enabled  := False;
Super.Enabled :=   False;
Button1.Enabled := False;

LI := ListView1.Selected;
if not Assigned(LI) then exit;

PR := PPlugs(LI.data);
if not Assigned(PR) then exit;

UnloadPlug.Enabled := PR^.Loaded;
LoadPlug.Enabled  :=  not PR^.Loaded;
Super.Enabled :=   PR^.IsSuper and PR^.Loaded;
Button1.Enabled := PR^.Loaded;
UnregisterPlug.Enabled := True;
LI.SubItems[1] := cStatus[PR^.Loaded];

end;

procedure TForm1.LoadPlugClick(Sender: TObject);
var
 LI:TListItem;
 PR:PPlugs;
 PlugGUID:TGUID;
 HR:HResult;

begin

if not Assigned(ListView1.Selected) then exit;
LI := ListView1.Selected;
PR := PPlugs(LI.Data);
        PlugGUID := StringToGuid(PR^.CLSID);

        HR := CoCreateInstance(PlugGUID,nil,CLSCTX_INPROC_SERVER,IID_IPlug,PR^.Int);
        if SUCCEEDED(HR) then
        begin

          PR^.Tab := TTabSheet.Create(PageControl1);
          PR^.Tab.PageControl := PageControl1;
          PR^.Tab.Caption := PR^.Name;
          If SUCCEEDED(PR^.Int.Init(Form1 as IPlugsApplication, PR^.Tab.Handle)) then
            PR^.Loaded := true
          else
            PR^.Tab.Free;
        end;



ListView1.SetFocus;
ListView1.Selected :=  LI;
ListView1.ItemFocused := LI;
ListView1Click(Sender);
end;

procedure TForm1.UnloadPlugClick(Sender: TObject);
var
 LI:TListItem;
 PR:PPlugs;
begin
if not Assigned(ListView1.Selected) then exit;
LI := ListView1.Selected;
PR := PPlugs(LI.Data);


        PR.Loaded := False;//PR^.Int._Release <> S_OK;
        PR^.Int := nil;
        PR^.Tab.Free;




ListView1.SetFocus;
ListView1.Selected :=  LI;
ListView1.ItemFocused :=  LI;
ListView1Click(Sender);
end;

procedure TForm1.Button1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
 I:Integer;
 PR:PPlugs;
 SC:String;
begin

if ListView1.Items.Count > 0 then
 for i:= 0 to ListView1.Items.Count -1 do
 begin
  PR := ListView1.Items[i].Data;
  if Assigned(PR) and PR^.Loaded then
  begin
   if Assigned(Sender) then
   begin
    SC := Sender.ClassName;
    if assigned(PR^.Int) then PR^.Int.Mouse(Pchar(SC),X,Y);
   end;
  end
 end;

end;

procedure TForm1.UnregisterPlugClick(Sender: TObject);
var
 LI:TListItem;
 PR:PPlugs;
 II:Integer;
begin

 II := ListView1.ItemIndex;
 if II < 0 then exit;

 LI := ListView1.Items[ii];
 PR := PPlugs(LI.Data);
 if PR.Loaded then
 begin
   PR.Loaded := False;//PR^.Int._Release <> S_OK;
   PR^.Int := nil;
   PR^.Tab.Free;
 end;
 
 if UnRegisterOCX(Handle,PR^.Path) then
 begin
  Dispose(PR);
  ListView1.Items.Delete(II);
 end;
 //LI.SubItems[2] := cStatus[PR^.Loaded];


end;

procedure TForm1.RegisterPlugClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
     RegisterOCX(Handle,OpenDialog1.Filename);
     ListPlugs;
  end;
end;

procedure TForm1.SuperClick(Sender: TObject);
var
 LI:TListItem;
 PR:PPlugs;
begin

if not Assigned(ListView1.Selected) then exit;
LI := ListView1.Selected;
PR := PPlugs(LI.Data);
if not Assigned(PR) then exit;
(PR^.Int as IPlugSuper).Super();

end;

procedure TForm1.Button1Click(Sender: TObject);
var
 LI:TListItem;
 PR:PPlugs;
 Name:PChar;
begin
if not Assigned(ListView1.Selected) then exit;
LI := ListView1.Selected;
PR := PPlugs(LI.Data);
if Assigned(PR) and PR^.Loaded then
begin
 OleCheck(PR^.Int.GetName(Name));
 MessageBox(handle,name,'',MB_OK);
 pMalloc.Free(Name);
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Form2.ShowModal;
end;

end.
