unit OCXUnit;
//***********************************
// Bartosz Reichel  (c)1998
// reichel@rudy.mif.pg.gda.pl (2006)
// 2006 - drobne poprawki kosmetyczne
//***********************************

interface
uses Windows;

const
   FNF = 'Nie  odnaleziono pliku "%s"';
   function RegisterOCX(HW:HWND;const S: String):Boolean;
   function UnRegisterOCX(HW:HWND;const S: String):Boolean;

implementation

uses {OLECtl, OLEAuto, }ActiveX, Registry, SysUtils,  ShellAPI;

const
  RegFunc   = 'DllRegisterServer';
  UnregFunc = 'DllUnregisterServer';
  NoFun = 'Bd w czasie adowania procesu %s';
  ErrLoadOCX = 'Bd w adowaniu kontrolki OCX: %s';
  UNREG = 'UnRegisterOCX';
  REG = 'RegisterOCX';

type  
  EOleError = class(Exception);

function RegisterOCX(HW:HWND;const S: String):Boolean;
var
   ModHand: Integer;
   R: TDLLRegisterServer;
   HR:HResult;
begin
  Result := False;

   ModHand := LoadLibrary(PChar(S));
   try
    if ModHand < 0 then
      raise EOleError.CreateFmt(ErrLoadOCX, [S])
    else begin
      R := GetProcAddress(ModHand, RegFunc);
      if @R = Nil then
           raise EOleError.CreateFmt(NoFun, [S])
      else begin
         HR := R;
         if HR <> S_OK then
           MessageBox(HW,PChar(Format('Bd w zarejestrowywaniu pliku  %s',[S])),nil,0)
         else
           Result := True;
      end;
    end;
   finally
       FreeLibrary(ModHand);
   end;

end;

function UnRegisterOCX(HW:HWND;const S: String):Boolean;
var
  ModHand: Integer;
  U: TDLLUnregisterServer;
  HR:HResult;
begin
  Result := False;

   ModHand := LoadLibrary(PChar(S));
   try
    if ModHand < 0 then
      raise EOleError.CreateFmt(ErrLoadOCX, [S])
    else begin
      U := GetProcAddress(ModHand, UnregFunc);
      if @U = Nil then begin
        raise EOleError.CreateFmt(NoFun, [S]);
      end
      else begin
         HR := U;
         if HR <> S_OK then
            MessageBox(HW,PChar(Format('Bd w odrejestrowywaniu pliku  %s',[S])),nil,0)
         else
           Result := True;
    end;
   end;
   finally
      FreeLibrary(ModHand);
   end;

end;



end.
