//*************************************
//          Reichel Bartosz
//          reichel@mif.pg.gda.pl
//          http://reichel.pl 
//          2006.08.19
//*************************************

unit swtyka;

interface

uses
  Windows, ActiveX, ComObj, ShlObj, Messages,  MyInterface, Unit1 ;



type
  TDelphiWtyczka = class(TComObject,IPlug)
  private
    FWind: TForm1;
  public
//IPlug
    function Init(ap:IPlugsApplication;TabH:HWND): HResult; stdcall;
    function Mouse(Name:PChar;X,Y:Integer): HResult; stdcall;
    function GetName(var Desc:PChar):HResult; stdcall;
    function FreePlug(): HResult; stdcall;
 public
    procedure  Initialize; override;
    destructor Destroy; override;
  end;

const

  CLSID_DelphiWtyczka: TGUID = '{A0D2EB0D-BF63-4C77-AE0D-89B0234711C9}';



implementation

uses ComServ, ShellAPI, SysUtils, Registry;


procedure TDelphiWtyczka.Initialize;
begin
//Tutaj incjujemy elementy potrzebne do dzialania naszego pluginu
  inherited;
end;

destructor TDelphiWtyczka.Destroy;
begin
  if Fwind <> nil then FWind.Close;
  inherited;
end;

function TDelphiWtyczka.Init(ap:IPlugsApplication;TabH:HWND): HResult;
begin
   if ap = nil then   //zakadamy, e aplikacja musi miec interfejs aplikacji
   begin
     result := E_FAIL;
     Exit;
   end;

   Fwind := TForm1.CreateP(TabH);
   Fwind.top := 10;
   Fwind.left := 10;
   Fwind.show;
   result := S_OK;
end;

function TDelphiWtyczka.Mouse(Name:PChar;X,Y:Integer): HResult;
begin
// Jesli zwrocimy, ze metoda jest niezaimplementowana
//aplikacja rodzic moe zareagowac na to w odpowiedni sposob.
//W najgorszym przypadku np stosujac funkcje OleCheck
//moze zwrocic wyjatek, ze metoda jest niezaimplementowna.
 result := E_NOTIMPL;
end;

function TDelphiWtyczka.GetName(var Desc:Pchar):HResult;
begin
 result := E_NOTIMPL;
end;

function TDelphiWtyczka.FreePlug(): HResult;
begin
  FWind.Close;
  Result := S_OK;
end;


type
  TPFSPlugFactory = class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: Boolean); override;
  end;

procedure TPFSPlugFactory.UpdateRegistry(Register: Boolean);
var
  ClassID: string;
begin
  if Register then begin
    inherited UpdateRegistry(Register);


          ClassID := GUIDToString(CLSID_DelphiWtyczka);
      with TRegistry.Create do
        try
          RootKey := HKEY_CURRENT_USER;
          OpenKey(szWtyczki+ClassID,True);
          CloseKey;
        finally
           Free;
        end;
  end
  else begin
       with TRegistry.Create do
        try
          RootKey := HKEY_CURRENT_USER;
              ClassID := GUIDToString(CLSID_DelphiWtyczka);
          DeleteKey(szWtyczki+ClassID);
        finally
           Free;
        end;
    inherited UpdateRegistry(Register);
  end;
end;

initialization
CoInitialize(nil);
  TPFSPlugFactory.Create(ComServer, TDelphiWtyczka, CLSID_DelphiWtyczka, '',
      'Wtyczka Delphi', ciMultiInstance, tmApartment);
finalization
CoUnInitialize;
end.

