//*************************************
//          Reichel Bartosz
//          reichel@mif.pg.gda.pl
//          http://reichel.pl 
//          2006.08.19
//*************************************
unit supimpl;

interface

uses
  Windows, ActiveX, ComObj, ShlObj, Messages,  MyInterface, Unit1 ;



type
  TDelphiSuperWtyczka = class(TComObject,IPlug, IPlugSuper)
  private
   pMalloc: IMalloc;
   Fwind: TSuperForma;
  public
//IPlug
    function Init(ap:IPlugsApplication;Tab:HWND): HResult; stdcall;
    function Mouse(Name:PChar;X,Y:Integer): HResult; stdcall;
    function GetName(var Desc:PChar):HResult; stdcall;
    function FreePlug(): HResult; stdcall;
//IPlugSuper
    function Super(): HResult; stdcall;
 public
    procedure  Initialize; override;
    destructor Destroy; override;
  end;

const

  CLSID_DelphiSuperWtyczka: TGUID = '{0A3963BD-DC55-4BC7-BBC6-C5771891F990}';



implementation

uses ComServ, ShellAPI, SysUtils, Registry;


procedure TDelphiSuperWtyczka.Initialize;
begin
  //Tu tworzymy potrzebne elementy
  Fwind := nil;
  //IMalloc to wygodny interfejs do nawigacji pamiecia w interfejsach
  SHGetMalloc(pMalloc);
  inherited;

end;

destructor TDelphiSuperWtyczka.Destroy;
begin
  if Fwind <> nil then  Fwind.Close;
  pMalloc := nil; //zwalniamy interfejs -> to samo co Realease
  inherited;
end;

function TDelphiSuperWtyczka.Init(ap:IPlugsApplication;Tab:HWND): HResult;
begin
   if ap = nil then
   begin
     result := E_FAIL;
     Exit;
   end;

   Fwind := TSuperForma.CreateP(tab,ap);
   Fwind.top := 10;
   Fwind.left := 10;
   Fwind.show;

   result := S_OK;
end;

function TDelphiSuperWtyczka.Mouse(name:Pchar;X,Y:Integer): HResult;
begin
if Assigned(Name) then
  FWind.Label2.Caption := Name;

FWind.Label1.caption := Format('Mysz na pozycji:'#13#10' X: %d, Y: %d',[X,Y]);
Result := S_OK;
end;

function TDelphiSuperWtyczka.GetName(var Desc:PChar):HResult;
const
  desz  =  'Super wtyczka delphi';
begin
 Desc := pMalloc.Alloc(Length(desz)+1);
 StrCopy(PChar(Desc),desz);
 //rezerwujemy pamiec, aplikacja rodzic jest odpowiedzialna za jej zwolnienie
 Result := S_OK;
end;

function TDelphiSuperWtyczka.FreePlug(): HResult;
begin
  Fwind.Close;
  result := S_OK; 
end;

function TDelphiSuperWtyczka.Super(): HResult;
begin
  MessageBox(GetFocus,PChar('Witaj, jestem Super Wtyczka'),'',0);
  Result := S_OK;
end;

type
  TSuperPlugFactory = class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: Boolean); override;
  end;

procedure TSuperPlugFactory.UpdateRegistry(Register: Boolean);
var
  ClassID: string;
begin
  if Register then begin
    inherited UpdateRegistry(Register);


          ClassID := GUIDToString(CLSID_DelphiSuperWtyczka);
      with TRegistry.Create do
        try
          RootKey := HKEY_CURRENT_USER;
          OpenKey(szWtyczki+ClassID,True);
          CloseKey;
        finally
           Free;
        end;
  end
  else begin
       with TRegistry.Create do
        try
          RootKey := HKEY_CURRENT_USER;
              ClassID := GUIDToString(CLSID_DelphiSuperWtyczka);
          DeleteKey(szWtyczki+ClassID);
        finally
           Free;
        end;
    inherited UpdateRegistry(Register);
  end;
end;

initialization
  CoInitialize(nil);
  TSuperPlugFactory.Create(ComServer, TDelphiSuperWtyczka, CLSID_DelphiSuperWtyczka, '',
    'Super Wtyczka Delphi', ciMultiInstance, tmApartment);
finalization
CoUnInitialize;
end.

